
function GSAjaxAPI(gwcgi,collect) 
{
    var gwcgi_   = gwcgi;
    var collect_ = collect;

    this.apiURL = function(apiProg)
    {
        //get the location of the cgi program
        splitpos = gwcgi_.lastIndexOf("/");

        var mdserver;
        if (splitpos >= 0) {
            mdserver = gwcgi.substring(0,(splitpos+1)) + apiProg;
        }
        else {
          mdserver = apiProg;
        }

       return mdserver;
    }

    this.metadataserverURL = function()
    {
        return this.apiURL("metadata-server.pl");
    }


    this.urlGetAsync = function(url,locid)
    {
       var xmlHttp;
       try {
         // Firefox, Opera 8.0+, Safari
         xmlHttp=new XMLHttpRequest();
       }
       catch (e) {
         // Internet Explorer
         try {
           xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
         }
         catch (e) {
           try {
             xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
           }
           catch (e) {
             alert("Your browser does not support AJAX!");
             return false;
           }
         }
       }
    
       xmlHttp.onreadystatechange=function() {
         if(xmlHttp.readyState==4) {
           if (locelem != null) {
             var locelem = document.getElementById(locid);
    
             locelem.innerHTML = xmlHttp.responseText;
           }
         }
       }
    
       xmlHttp.open("GET",url,true);
       xmlHttp.send(null);
    }
    
        
    this.urlGetSync = function(url)
    {
	// alert("url = " + url);

       var xmlHttp;
       try {
         // Firefox, Opera 8.0+, Safari
         xmlHttp=new XMLHttpRequest();
       }
       catch (e) {
         // Internet Explorer
         try {
           xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
         }
         catch (e) {
           try {
             xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
           }
           catch (e) {
             alert("Your browser does not support AJAX!");
             return false;
           }
         }
       }
    
       xmlHttp.open("GET",url,false);
       xmlHttp.send(null);

       // alert("response = '" + xmlHttp.responseText + "'");
    
       return xmlHttp.responseText;
    }
    
    
    this.setLiveMetadata = function(id,metaname,metavalue)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=set-live-metadata";
        url += "&c="+collect_;
        url += "&d="+id;
        url += "&metaname=" + metaname;
        url += "&metavalue=" + metavalue;

	//alert("url = " + url);

        this.urlGetSync(url);
    }
    
	 this._setMetadata = function(mode,docid,metaname,metapos,metavalue,metamode)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=set" + mode + "-metadata";
        url += "&c="+collect_;
        url += "&d="+docid;
        url += "&metaname=" + metaname;
        if (metapos!=null) {
            url += "&metapos=" + metapos;
        }
        url += "&metavalue=" + metavalue;
		if (metamode!=null) {
            url += "&metamode=" + metamode;
        }
	// alert("url = " + url);
    
        this.urlGetSync(url);
    }
    
    this.setDocumentMetadata = function(docid,metaname,metapos,metavalue)
    {
		// Allow for three param call to function, where metapos is missed out
        if (metavalue==null) {
	    // 4 param case
	    metavalue = metapos;
	    metapos = null;
		}
	
		this._setMetadata("",docid,metaname,metapos,metavalue);
		// this._setMetadata("-archives",docid,metaname,metapos,metavalue,"override");
    }

	 this.setNewDocumentMetadata = function(docid,metaname,metavalue)
    {
		this._setMetadata("",docid,metaname,null,metavalue);
		this._setMetadata("-archives",docid,metaname,null,metavalue,"accumulate");
    }
	
	this.setImportMetadata = function(docid,metaname,metapos,metavalue)
    {
		this._setMetadata("-import",docid,metaname,metapos,metavalue);
    }
	

    this.documentReindex = function(docid)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=reindex-document";
        url += "&c="+collect_;
        url += "&d="+docid;

	// alert("url = " + url);
    
        this.urlGetSync(url);
    }
    
    this.getLiveMetadata = function(id,metaname)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=get-live-metadata";
        url += "&c="+collect_;
        url += "&d="+id;
        url += "&metaname=" + metaname;

	//alert("url = " + url);    

        var metavalue = this.urlGetSync(url);
    
        //alert("metavalue = " + metavalue);

        return metavalue;
    }
    
    this.getDocumentMetadata = function(docoid,metaname,metapos)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=get-metadata";
        url += "&c="+collect_;
        url += "&d="+docoid;
        url += "&metaname=" + metaname;
        if (metapos!=null) {
            url += "&metapos=" + metapos;
        }

        return this.urlGetSync(url);
    }



    
    this.removeLiveMetadata = function(id,metaname)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=remove-live-metadata";
        url += "&c="+collect_;
        url += "&d="+id;
        url += "&metaname=" + metaname;

	//alert("url = " + url);

        this.urlGetSync(url);
    }
    
    
    this.removeDocumentMetadata = function(docid,metaname,metapos)
    {
        var mdserver = this.metadataserverURL();
    
        var url = mdserver + "?a=remove-metadata";
        url += "&c="+collect_;
        url += "&d="+docid;
        url += "&metaname=" + metaname;
        if (metapos!=null) {
            url += "&metapos=" + metapos;
        }

	//alert("url = " + url);
    
        this.urlGetSync(url);
    }


    return true;

}